<template>
  <input
    :id="id"
    :checked="modelValue ?? false"
    :class="classes"
    :name="name"
    :required="required"
    class="h-4 w-4 cursor-pointer rounded border-gray-300 text-primary-500 focus:ring-primary-500"
    type="checkbox"
    @input="$emit('update:modelValue', ($event.target as HTMLInputElement).checked)"
    @click.stop
  />
</template>

<script lang="ts" setup>
import type { ComputedRef } from "vue";

defineProps<{
  name: string;
  modelValue: boolean | null;
  required?: boolean;
}>();

defineEmits<{
  "update:modelValue": [value: boolean | null];
}>();

const id = inject<string | undefined>("id", undefined);
const errors = inject<ComputedRef<boolean> | undefined>("errors", undefined);

const classes = computed(() => ({
  "border-red-500 focus:ring-red-600": errors?.value,
}));
</script>
